# ]po[ Timesheet Core
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](https://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](https://www.project-open.com/en/list-installers)

About ]po[ Timesheet Core:

<p><p><p>The Advanced Timesheet Management Package and it&#39;s accompanying add-on packages are ]project-open[&#39;s solution for logging and tracking employee time. Although the package is capable of simply recording employees as they &quot;punch in and out&quot;; in a project management environment, and moreover, to a project manager, it is of more importance to know on what specific tasks and projects an employee has spent their time, and for service consultants to be able to transform these records automatically into billable statements to spend to clients. Within their base timesheet, employees can associate their work with specific projects, sub-projects, or specific tasks within the two. This allows project managers to spot possible project delays, to identify man hour intensive project areas, and track individual employee efficiency and effectiveness. <p><p><img src="https://www.project-open.com/images/manual_screenshots/screenshot_timesheet.gif" /><p> (Screenshot of a timesheet for &quot;Ben Bigboss&quot; recording his hours spent on the &quot;Fast Food Regional Market Analysis&quot; project.) <p><ul><ul><li>A per-employee hourly rate allows to implement <a href="https://en.wikipedia.org/wiki/Activity-based_costing" title="Activity Based Costing">ABC (Activity Based Costing)</a> and <a href="https://en.wikipedia.org/wiki/Full_cost_accounting" title="Full Cost Accounting">FCA (Full Cost Accounting)</a> methodologies.<li>A per-group hourly rate allows to implement <a href="https://en.wikipedia.org/wiki/International_Accounting_Standards" title="International Accounting Standards">IAS (International Accounting Standards)</a> compliant WIP (Work in Progress) reporting.<li>A per-company average hourly rate allows to calculate WIP on a global average.</ul></ul><p><p>There are several different ways to access view timesheets on ]project-open[. <ul><li><strong>For a monthly calendar view </strong>click on the &quot;Timesheet&quot; header from anywhere in ]project-open[, then select the day that you wish you record hours for. A menu of all projects you are associated with is presented, select the particular project, enter in the hours and then click &quot;Add hours&quot; to update. </ul><ul><li><strong>For a weekly view </strong>click on the &quot;Project&quot; home page and select the desired project. From within that particular&#39;s project home page click on the &quot;Log in your hours&quot; link beneath the &quot;Timesheet&quot; header which will lead to a page showing a week view.</ul><p><img src="https://www.project-open.com/images/manual_screenshots/screenshot_timesheet_1.gif" /><p> (Screenshot from a specific project homepage of the timesheet component) <p>

# Online Reference Documentation

## Accessing a timesheet and recording hours in ]project-open[



## Procedure Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=48279&amp;path=packages/intranet-timesheet2/tcl/intranet-absences-procs.tcl">tcl/intranet-absences-procs.tcl</a></b></td><td></td><td>Definitions for the intranet timesheet </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=48279&amp;path=packages/intranet-timesheet2/tcl/intranet-calendar-procs.tcl">tcl/intranet-calendar-procs.tcl</a></b></td><td></td><td>reviewed by philg@mit.edu, June 1999 for release with ACS 2.0 documentation and example in /www/doc/calendar-widget.html smeeks@arsdigita.com, June 2000 Added new widgets for new-calendar Documentation eventually in /www/doc/new-calendar-widgets.html </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=48279&amp;path=packages/intranet-timesheet2/tcl/intranet-timesheet2-procs.tcl">tcl/intranet-timesheet2-procs.tcl</a></b></td><td></td><td>Definitions for the intranet timesheet </td></tr></table>

## Procedures

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=absence_list_for_user_and_time_period">absence_list_for_user_and_time_period</a></b></td><td></td><td>For a given user and time period, this proc returns a list of elements where each element corresponds to one day and describes its &quot;work/vacation type&quot;. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=calculate_absence_days">calculate_absence_days</a></b></td><td></td><td>Calculates the days considering Returns absence as UOM &#39;hours&#39; </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=calculate_dd_hh_mm_from_day">calculate_dd_hh_mm_from_day</a></b></td><td></td><td>Returns list {dd hh mm } </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=calendar_basic_month">calendar_basic_month</a></b></td><td></td><td>Returns a calendar for a specific month, with details supplied by Julian date. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=calendar_convert_julian_to_ansi">calendar_convert_julian_to_ansi</a></b></td><td></td><td>Return an ANSI date for a Julian date </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=calendar_get_info_from_db">calendar_get_info_from_db</a></b></td><td></td><td>Calculates various dates required by the calendar_basic_month procedure. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=calendar_prev_current_next">calendar_prev_current_next</a></b></td><td></td><td>Returns a calendar for a specific month, with details supplied by Julian date. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=calendar_small_calendar_year">calendar_small_calendar_year</a></b></td><td></td><td>Returns a calendar year of small calendars for the year of the passed in date. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=calendar_small_month">calendar_small_month</a></b></td><td></td><td>Returns a small calendar for a specific month. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=calendar_small_year">calendar_small_year</a></b></td><td></td><td>Returns a year of small calendars given the starting month as a date. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=get_unconfirmed_hours_for_period">get_unconfirmed_hours_for_period</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_color_table">im_absence_color_table</a></b></td><td></td><td>Returns some HTML with a table with the colors of absences </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_cube">im_absence_cube</a></b></td><td></td><td>Returns a rendered cube with a graphical absence display for users. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_cube_color_list">im_absence_cube_color_list</a></b></td><td></td><td>Returns the list of colors for the various types of absences </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_cube_color_list_helper">im_absence_cube_color_list_helper</a></b></td><td></td><td>Returns the list of colors for the various types of absences </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_cube_render_cell">im_absence_cube_render_cell</a></b></td><td></td><td>Renders a single report cell, which might contain an intersection of multiple type of absences. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_formatted_duration_to_days">im_absence_formatted_duration_to_days</a></b></td><td></td><td>Converts a time string to days. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_mix_colors">im_absence_mix_colors</a></b></td><td></td><td>Renders a single report cell. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_new_page_wf_perm_delete_button">im_absence_new_page_wf_perm_delete_button</a></b></td><td></td><td>Should we show the &quot;Delete&quot; button in the AbsenceNewPage? The button is visible only for the Owner of the absence, but nobody else in the WF. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_new_page_wf_perm_edit_button">im_absence_new_page_wf_perm_edit_button</a></b></td><td></td><td>Should we show the &quot;Edit&quot; button in the AbsenceNewPage? The button is visible only for the Owner of the absence and the Admin, but nobody else during the course of the WF. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_new_page_wf_perm_table">im_absence_new_page_wf_perm_table</a></b></td><td></td><td>Returns a hash array representing (role x status) -&gt; (v r d w a), controlling the read and write permissions on absences, depending on the users&#39;s role and the WF status. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_type_color">im_absence_type_color</a></b></td><td></td><td>Returns the color for an absence or an absence_type_id. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_type_color_helper">im_absence_type_color_helper</a></b></td><td></td><td>Returns the color for an absence or an absence_type_id. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_vacation_balance_component">im_absence_vacation_balance_component</a></b></td><td></td><td>Returns a HTML component showing the number of days left for the user </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_vacation_balance_component_ajax">im_absence_vacation_balance_component_ajax</a></b></td><td></td><td>Returns a HTML component for vacation management. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absence_vacation_balance_component_xhtml">im_absence_vacation_balance_component_xhtml</a></b></td><td></td><td>Returns a HTML component for vacation management. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_absences_assign_vacation_replacement">im_absences_assign_vacation_replacement</a></b></td><td></td><td>Assigns a vacation replacement to a task </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_force_user_to_log_hours">im_force_user_to_log_hours</a></b></td><td></td><td>If a user is not on vacation and has not logged hours since yesterday midnight, we ask them to log hours before using the intranet. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_get_next_absence_link">im_get_next_absence_link</a></b></td><td></td><td>Returns a html link with the next &quot;personal&quot;absence of the given user_id. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_hour_nuke">im_hour_nuke</a></b></td><td></td><td>Delete an im_hour entry and depending objects. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_hour_permissions">im_hour_permissions</a></b></td><td></td><td>Fill the by-reference variables read, write and admin with the permissions of $user_id on $hour_id </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_hours_for_user">im_hours_for_user</a></b></td><td></td><td>Returns a string in html or text format describing the number of hours the specified user logged and what s/he noted as work done in those hours. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_hours_verify_user_id">im_hours_verify_user_id</a></b></td><td></td><td>Returns either the specified user_id or the currently logged in user&#39;s user_id. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_menu_absences_admin_links">im_menu_absences_admin_links</a></b></td><td></td><td>Return a list of admin links to be added to the &quot;absences&quot; menu </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_menu_timesheet_admin_links">im_menu_timesheet_admin_links</a></b></td><td></td><td>Return a list of admin links to be added to the &quot;timesheet&quot; menu </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_package_timesheet2_id">im_package_timesheet2_id</a></b></td><td></td><td>Returns the package id of the intranet-timesheet2 package </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_timesheet2_sync_timesheet_costs">im_timesheet2_sync_timesheet_costs</a></b></td><td></td><td>Check for im_hour items without associated timesheet cost items and generate the required items. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_timesheet_absences_sum">im_timesheet_absences_sum</a></b></td><td></td><td>Returns the total number of absences multiplied by 8 hours per absence. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_timesheet_costs_delete">im_timesheet_costs_delete</a></b></td><td></td><td>Delete any cost items related to hours logged for the specified project and day. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_timesheet_home_component">im_timesheet_home_component</a></b></td><td></td><td>Creates a HTML table showing a box with basic statistics about the current project and a link to log the users hours. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_timesheet_hours_sum">im_timesheet_hours_sum</a></b></td><td></td><td>Returns the total number of hours the specified user logged for whatever else is included in the arg list. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_timesheet_project_component">im_timesheet_project_component</a></b></td><td></td><td>Creates a HTML table showing a box with basic statistics about the current project and a link to log the users hours. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_timesheet_update_timesheet_cache">im_timesheet_update_timesheet_cache</a></b></td><td></td><td>Returns the total hours registered for the specified table and id. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_nuke">im_user_absence_nuke</a></b></td><td></td><td>Delete an im_hour entry and depending objects. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_permissions">im_user_absence_permissions</a></b></td><td></td><td>Fill the &quot;by-reference&quot; variables read, write and admin with the permissions of $user_id on $absence_id. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_status_active">im_user_absence_status_active</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_status_deleted">im_user_absence_status_deleted</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_status_rejected">im_user_absence_status_rejected</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_status_requested">im_user_absence_status_requested</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_type_bank_holiday">im_user_absence_type_bank_holiday</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_type_personal">im_user_absence_type_personal</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_type_sick">im_user_absence_type_sick</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_type_training">im_user_absence_type_training</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_type_travel">im_user_absence_type_travel</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=im_user_absence_type_vacation">im_user_absence_type_vacation</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=48279&amp;proc=mini_calendar_widget">mini_calendar_widget</a></b></td><td></td><td>&quot;This proc creates a mini calendar useful for navigating various calendar views. </td></tr></table>

## SQL Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2&amp;url=common/intranet-timesheet-backup.sql&amp;version_id=48279">sql/common/intranet-timesheet-backup.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2&amp;url=common/intranet-timesheet-common.sql&amp;version_id=48279">sql/common/intranet-timesheet-common.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2&amp;url=postgresql/aux_delete_timesheet_costs.sql&amp;version_id=48279">sql/postgresql/aux_delete_timesheet_costs.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2&amp;url=postgresql/intranet-absences-create.sql&amp;version_id=48279">sql/postgresql/intranet-absences-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2&amp;url=postgresql/intranet-absences-workflow.sql&amp;version_id=48279">sql/postgresql/intranet-absences-workflow.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2&amp;url=postgresql/intranet-timesheet2-create.sql&amp;version_id=48279">sql/postgresql/intranet-timesheet2-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2&amp;url=postgresql/intranet-timesheet2-drop.sql&amp;version_id=48279">sql/postgresql/intranet-timesheet2-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2&amp;url=postgresql/upgrade/upgrade-5.0.1.0.0-5.0.1.0.1.sql&amp;version_id=48279">sql/postgresql/upgrade/upgrade-5.0.1.0.0-5.0.1.0.1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2&amp;url=postgresql/upgrade/upgrade-5.0.1.0.1-5.0.1.0.2.sql&amp;version_id=48279">sql/postgresql/upgrade/upgrade-5.0.1.0.1-5.0.1.0.2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2&amp;url=postgresql/upgrade/upgrade-5.0.1.0.2-5.0.1.0.3.sql&amp;version_id=48279">sql/postgresql/upgrade/upgrade-5.0.1.0.2-5.0.1.0.3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-timesheet2&amp;url=postgresql/upgrade/upgrade-5.0.2.5.1-5.0.2.5.2.sql&amp;version_id=48279">sql/postgresql/upgrade/upgrade-5.0.2.5.1-5.0.2.5.2.sql</a></b></td><td></td><td></td></tr></table>

## Content Pages

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b>www/</b></td></tr><tr valign="top"><td><b>absences/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/absence-duration.tcl">absence-duration.tcl</a></b></td><td>Calculate the duration of an absence in days or hours, including public holidays for the specific user.</td></tr><tr valign="top"><td><b>admin/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/admin/index.tcl">index.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/capacity-planning-2.tcl">capacity-planning-2.tcl</a></b></td><td>Capacity planning</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/capacity-planning.adp">capacity-planning.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/capacity-planning.tcl">capacity-planning.tcl</a></b></td><td>Capacity planning</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/dashboard.adp">dashboard.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/dashboard.tcl">dashboard.tcl</a></b></td><td>Ticket Dashboard</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/index.tcl">index.tcl</a></b></td><td>Shows all absences.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/new.adp">new.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/new.tcl">new.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/vacation-balance-component.adp">vacation-balance-component.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/vacation-balance-component.tcl">vacation-balance-component.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/xhtml-vacation-balance-component.adp">xhtml-vacation-balance-component.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/absences/xhtml-vacation-balance-component.tcl">xhtml-vacation-balance-component.tcl</a></b></td><td>Shows the vacation balance for the user.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/dedication_days_em.tcl">dedication_days_em.tcl</a></b></td><td>Purpose: See the employees project dedication status</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/dedication_days_pr.tcl">dedication_days_pr.tcl</a></b></td><td>Purpose: See the employees project dedication status</td></tr><tr valign="top"><td><b>hours/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/admin.adp">admin.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/admin.tcl">admin.tcl</a></b></td><td>Home page for category administration.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/dashboard.adp">dashboard.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/dashboard.tcl">dashboard.tcl</a></b></td><td>Ticket Dashboard</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/full.adp">full.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/full.tcl">full.tcl</a></b></td><td>Shows a detailed list of all the hours one user spent on a given item (e.g.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/history.tcl">history.tcl</a></b></td><td>Shows a history of hours logged for a project by all employees over a period of time (several weeks/months)</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/index.tcl">index.tcl</a></b></td><td>Calendar format display of user&#39;s hours with links to log more hours, if the user is looking at him/ herself</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/month.adp">month.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/month.tcl">month.tcl</a></b></td><td>Shows the hour a specified user spend working over the course of a month</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/new-2.tcl">new-2.tcl</a></b></td><td>Writes hours to db.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/new.adp">new.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/new.tcl">new.tcl</a></b></td><td>Displays form to let user enter hours In weekly view, week would start with julian_date which is usually a Sunday or Monday</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/one-project.adp">one-project.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/one-project.tcl">one-project.tcl</a></b></td><td>Shows hours by all users for a specific item/project</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/one.adp">one.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/one.tcl">one.tcl</a></b></td><td>Edit an existing timesheet element to allow an Admin to assign the hours to a different project.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/other-projects.adp">other-projects.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/other-projects.tcl">other-projects.tcl</a></b></td><td>Display the list of available project for the current user in order to allow logging hours on project where the current user isn&#39;t a member of.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/projects.adp">projects.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/projects.tcl">projects.tcl</a></b></td><td>Shows all the hours an employee has worked, organized by project</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/send_pr_info-2.tcl">send_pr_info-2.tcl</a></b></td><td>Purpose: Send project status info by e-mail (action)</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/send_pr_info.tcl">send_pr_info.tcl</a></b></td><td>Purpose: Send project status info by e-mail</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/total.adp">total.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/total.tcl">total.tcl</a></b></td><td>Shows total number of hours spent on all project</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/week.adp">week.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/hours/week.tcl">week.tcl</a></b></td><td>Shows the hour a specified user spend working over the course of a week</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/index.tcl">index.tcl</a></b></td><td></td></tr><tr valign="top"><td><b>reports/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/reports/details_monthly.tcl">details_monthly.tcl</a></b></td><td>Show the details of all hours logged by all employees in a single month.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/resource-report.tcl">resource-report.tcl</a></b></td><td>Show a timeline of the activities of a selected group of users.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/send_pr_info-2.tcl">send_pr_info-2.tcl</a></b></td><td>Purpose: Send project status info by e-mail (action)</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/send_pr_info.tcl">send_pr_info.tcl</a></b></td><td>Purpose: Send project status info by e-mail</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/weekly_report.adp">weekly_report.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=48279&amp;path=packages/intranet-timesheet2/www/weekly_report.tcl">weekly_report.tcl</a></b></td><td></td></tr></table>

